
package gov.nih.nci.coppa.po.grid.ser;

import java.util.HashMap;
import java.util.Map;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;
import javax.xml.namespace.QName;
import org.apache.axis.encoding.DeserializationContext;
import org.apache.axis.encoding.Deserializer;
import org.apache.axis.encoding.DeserializerImpl;
import org.apache.axis.message.MessageElement;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.xml.sax.SAXException;

/**
 *
 * @author gax
 */
public class JaxbDeserializer
        extends DeserializerImpl
        implements Deserializer {

	static final Logger logger = LogManager.getLogger(JaxbDeserializer.class);
    static Map<String,JAXBContext> jaxbContexts =  new HashMap<String,JAXBContext>();

    public void initContexts() throws IllegalStateException {
    	try {
    		jaxbContexts.put("gov.nih.nci.coppa.po", JAXBContext.newInstance("gov.nih.nci.coppa.po"));
    	}catch(Exception e){
    		logger.error("Error initializing JAXB Contexts", e);
    		throw new IllegalStateException("Error initializing JAXB Contexts", e);
    	}
    }

    public QName xmlType;
    public Class javaType;

    public JaxbDeserializer(Class javaType, QName xmlType) {
        this.xmlType = xmlType;
        this.javaType = javaType;
    }

    /**
     * Return something even if no characters were found.
     */
    public void onEndElement(
            String namespace,
            String localName,
            DeserializationContext context)
            throws SAXException {
        try {
            MessageElement msgElem = context.getCurElement();
            if (msgElem != null) {
                // Unmarshall the nested XML element into a jaxb object of type 'javaType'
                JAXBContext jaxbContext = jaxbContexts.get(javaType.getPackage().getName());
				if (jaxbContext == null) {
				   	jaxbContext = JAXBContext.newInstance(javaType.getPackage().getName());
				   	jaxbContexts.put(javaType.getPackage().getName(), jaxbContext);
                }
                Unmarshaller unmarshaller = jaxbContext.createUnmarshaller();
                value = unmarshaller.unmarshal(msgElem.getAsDOM());
            }
        } catch (Exception e) {
            throw new SAXException(e);
        }
    }
}