package gov.nih.nci.coppa.po.grid.ser;

import gov.nih.nci.cagrid.encoding.AxisContentHandler;

import java.util.HashMap;
import java.util.Map;

import java.io.IOException;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.namespace.QName;
import org.apache.axis.Constants;
import org.apache.axis.encoding.SerializationContext;
import org.apache.axis.encoding.Serializer;
import org.apache.axis.wsdl.fromJava.Types;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;
import org.w3c.dom.Element;
import org.xml.sax.Attributes;

/**
 *
 * @author gax
 */
public class JaxbSerializer implements Serializer {

	static Map<String,JAXBContext> jaxbContexts =  new HashMap<String,JAXBContext>();
	static final Logger logger = LogManager.getLogger(JaxbSerializer.class);


	public void initContexts() throws IllegalStateException {
	    	try {
	    		jaxbContexts.put("gov.nih.nci.coppa.po", JAXBContext.newInstance("gov.nih.nci.coppa.po"));
	    	}catch(Exception e){
	    		logger.error("Error initializing JAXB Contexts", e);
	    		throw new IllegalStateException("Error initializing JAXB Contexts", e);
	    	}
    }

    /**
     * Serialize a JAXB object.
     *
     * @param name
     * @param attributes
     * @param value      this must be a JAXB object for marshalling
     * @param context
     * @throws IOException for XML schema noncompliance, bad object type, and any IO
     *                     trouble.
     */
    public void serialize(QName name,
                          Attributes attributes,
                          Object value,
                          SerializationContext context)
            throws IOException {
        try {
            JAXBContext jaxbContext = jaxbContexts.get(value.getClass().getPackage().getName());
            if (jaxbContext == null) {
            	jaxbContext = JAXBContext.newInstance(value.getClass().getPackage().getName());
            	jaxbContexts.put(value.getClass().getPackage().getName(), jaxbContext);
            }
            Marshaller marshaller = jaxbContext.createMarshaller();

            marshaller.setProperty(Marshaller.JAXB_FRAGMENT, Boolean.TRUE);
//            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            marshaller.marshal(value, new Filter(context));

        } catch (Exception e) {
            e.printStackTrace();
            throw new IOException(e.getMessage());
        }
    }

    public String getMechanismType() {
        return Constants.AXIS_SAX;
    }

    /**
     * Return XML schema for the specified type, suitable for insertion into
     * the &lt;types&gt; element of a WSDL document, or underneath an
     * &lt;element&gt; or &lt;attribute&gt; declaration.
     *
     * @param javaType the Java Class we're writing out schema for
     * @param types    the Java2WSDL Types object which holds the context
     *                 for the WSDL being generated.
     * @return a type element containing a schema simpleType/complexType
     * @see org.apache.axis.wsdl.fromJava.Types
     */
    public Element writeSchema(Class javaType, Types types) throws Exception {
        return null;
    }
}
